From b4f98d3f45acae9cfe5ce0412d55e050f4d76cb0 Mon Sep 17 00:00:00 2001
From: =?utf-8?q?Rafa=C5=82=20Mi=C5=82ecki?= <zajec5@gmail.com>
Date: Fri, 26 Jun 2009 20:39:26 +0200
Subject: [PATCH] LVTMA: Don't drop backlight control just because it's disabled by default

Similar patch just gone for DIG. We can still control backlight even it it is
disabled (control) by default.
---
 src/rhd_lvtma.c |   25 ++++++++++++++++++++-----
 1 files changed, 20 insertions(+), 5 deletions(-)

diff --git a/src/rhd_lvtma.c b/src/rhd_lvtma.c
index b24bf5f..c92c14f 100644
--- a/src/rhd_lvtma.c
+++ b/src/rhd_lvtma.c
@@ -199,6 +199,24 @@ LVDSDebugBacklight(struct rhdOutput *Output)
 	    BlModLevel, BlModRes);
 }
 
+static void
+LVDSGetBacklight(struct rhdOutput *Output)
+{
+    struct LVDSPrivate *Private = (struct LVDSPrivate *) Output->Private;
+    RHDPtr rhdPtr = RHDPTRI(Output);
+
+    if (RHDRegRead(Output, LVTMA_BL_MOD_CNTL) & 0x1) {
+        int level = RHDRegRead(Output, LVTMA_BL_MOD_CNTL);
+        level >>= 8;
+        level &= 0xff;
+        Private->BlLevel = level;
+    }
+    else {
+        /* backlight control not enabled yet, this should mean maximum */
+        Private->BlLevel = 255;
+    }
+}
+
 /*
  *
  */
@@ -615,11 +633,6 @@ LVDSInfoRetrieve(RHDPtr rhdPtr)
     tmp = RHDRegRead(rhdPtr, LVTMA_PWRSEQ_REF_DIV);
     Private->PowerRefDiv = tmp & 0x0FFF;
     Private->BlonRefDiv = (tmp >> 16) & 0x0FFF;
-    tmp = RHDRegRead(rhdPtr, LVTMA_BL_MOD_CNTL);
-    if (tmp & 0x1)
-	Private->BlLevel = (tmp >> 8) & 0xff;
-    else
-	Private->BlLevel = -1; /* Backlight control seems to be done some other way */
 
     Private->DualLink = (RHDRegRead(rhdPtr, LVTMA_CNTL) >> 24) & 0x00000001;
     Private->LVDS24Bit = RHDRegRead(rhdPtr, LVTMA_LVDS_DATA_CNTL) & 0x00000001;
@@ -1367,6 +1380,8 @@ RHDLVTMAInit(RHDPtr rhdPtr, CARD8 Type)
 	Output->Property = LVDSPropertyControl;
 	Output->Destroy = LVDSDestroy;
 	Output->Private = Private =  LVDSInfoRetrieve(rhdPtr);
+
+	LVDSGetBacklight(Output);
 #ifdef NOT_YET
 	if (Private->BlLevel < 0) {
 	    Private->BlLevel = RhdAtomSetupBacklightControlProperty(Output, &Private->WrappedPropertyCallback,
-- 
1.6.0.2

